! This software is based on PROGRESS.F90 which is part of the 
! Compaq Visual Fortran kit.
! Copyright (C) 1998,1999 Digital Equipment Corporation.
! All rights reserved.
! 
! This software is furnished to you under a license by  Digital Equipment
! Corporation and must be used only in  accordance with the terms and conditions
! of that license,  and only with the inclusion of the above copyright notice.
! 
! 
!
!
!  FUNCTIONS:
!	WinMain()      - Entry point for the application;
!                    displays the main window; processes the message loop
!	ProgressSub()  - Callback routine for the main dialog box
!	StartWork()    - Setup for beginning the operation
!	ProgressStart()- Callback routine for the Start button
!	StopWork()     - Cleanup for stopping the operation
!	ProgressStop() - Callback routine for the Stop button
!

!****************************************************************************
!
!  FUNCTION: WinMain( hInstance, hPrevInstance, lpszCmdLine, nCmdShow )
!
!  PURPOSE:  Entry point for the application
!
!  COMMENTS: Displays the main window and processes the message loop
!
!****************************************************************************

integer*4 function WinMain( hInstance, hPrevInstance, lpszCmdLine, nCmdShow )
!DEC$ IF DEFINED(_X86_)
!DEC$ ATTRIBUTES STDCALL, ALIAS : '_WinMain@16' :: WinMain
!DEC$ ELSE
!DEC$ ATTRIBUTES STDCALL, ALIAS : 'WinMain' :: WinMain
!DEC$ ENDIF

	use dfwin
	use dflogm
	use GSGlobals
	!use EpsilonCalc

	implicit none

	integer*4 hInstance
	integer*4 hPrevInstance
	integer*4 lpszCmdLine
	integer*4 nCmdShow

	include 'resource.fd'

	external GSSub
	external GSStart
	external GSStop
	

	

	! Variables
	type (dialog)			dlg
	type (T_MSG)            mesg
	integer*4			    ret
	integer*4			    hwnd
	logical*4				lret
	logical*4				lNotQuit

	ghInstance = hInstance
	ghModule = GetModuleHandle(NULL)
	gSetFocus = 0

	! Display the main dialog box
	lret = DlgInit(IDD_GS_DIALOG, dlg)
	lret = DlgSetSub(dlg, IDD_GS_DIALOG, GSSub)
	lret = DlgSetSub(dlg, IDM_START, GSStart)


	!lret = DlgSetSub(dlg, IDM_STOP, ProgressStop)
	call StopWork( dlg )
	lret = DlgModeless(dlg, nCmdShow)

	! Read and process messsages
	! If there are no messages waiting, go off and do a
	! little bit of work.  We don't want it to take too
	! long, or the Dialog Box will not be responsive.
	lNotQuit = .true.
	do while (lNotQuit) 
		if (gDoWork) then
			do while (PeekMessage(mesg, 0, 0, 0, PM_NOREMOVE) == 0 .and. gDoWork)
				! Do work here....
				call sleepqq(250)		! Wait .25 seconds, 100 times
				! Update the progress bar as we proceed...
				gCurrentPercentage = gCurrentPercentage + 1
!				lret = DlgSet(dlg, IDC_PROGRESS1, gCurrentPercentage)
				if (gCurrentPercentage == 100) then
					call StopWork( dlg )
				end if
			end do
		end if;

		! There is at least one message waiting; process it
		! Note that DlgIsDlgMessage must be called in order to give
		! the dialog box first chance at the message.
		lNotQuit = GetMessage(mesg, NULL, 0, 0)
		if (lNotQuit) then
			if ( DlgIsDlgMessage(mesg) .EQV. .FALSE. ) then
			   lret = TranslateMessage( mesg )
			   ret  = DispatchMessage( mesg )
			end if
			! This code is used to move the input focus to an enabled button
			! It calls Win32 APIs directly.
			if (gSetFocus .ne. 0) then
				hwnd = GetDlgItem(dlg % hwnd, gSetFocus)
				hwnd = SetFocus(hwnd)
				gSetFocus = 0
			end if
		end if
	end do

	! Cleanup dialog box memory
	call DlgUninit(dlg)

	WinMain = mesg.wParam
	return

99999 &

	ret = MessageBox(ghwndMain, "Error initializing application progress"C, &
					 "Error"C, MB_OK)
	WinMain = 0

end 

!****************************************************************************
!
!  FUNCTION: ProgressSub ( dlg, id, callbacktype )
!
!  PURPOSE:  Dialog box callback for initialization and destroy
!
!  COMMENTS:
!
!****************************************************************************

SUBROUTINE GSSub( dlg, id, callbacktype )

  use dfwin
  use dflogm
  use GSGlobals

  implicit none

  type (dialog) dlg
  integer id, callbacktype

  ! When the user presses the "Exit" button, the default callback
  ! calls DLGEXIT which calls this callback with 
  ! callbacktype == dlg_destroy.  We call PostQuitMessage to cause
  ! the message loop in WinMain to terminate.
  if (callbacktype == dlg_destroy) then
	call PostQuitMessage(0)
  end if

  END SUBROUTINE GSSub






!****************************************************************************
!
!  FUNCTION: StartWork ( dlg )
!
!  PURPOSE:  Set up for starting work
!
!  COMMENTS:
!
!****************************************************************************

SUBROUTINE StartWork( dlg )

  use dflogm
  use GSGlobals
USE DFPORT
  implicit none

  include 'resource.fd'
	logical*4 status
  type (dialog) dlg
  character*500 value
  character*500 values(10)
  character*2 dummy
	
  integer hwnd
  logical lret
integer i, j
	gDoWork = .true.
	status = DlgGet(dlg, IDC_NUMEQ, value)
	read (value,*) NumEQ
	status = DlgGet(dlg, IDC_MAXERROR, value)
	read (value,*) MaxError
	status = DlgGet(dlg, IDC_CONSTANTLIST, value)
	do 21 i=1,10
		lret = DlgSet ( dlg, IDC_SOLUTIONLIST, "", i )
21	continue
	!This is one line, so just grab it all but count values to determine array dimension
1	format ( 10F7.3)
	!do 11 i=1,10
		read (value,*) (B(i), i=1,NumEq)
!11	continue
	!This is up to ten lines.  Grab one line at a time, parse.  Count loops
!	status = DlgGet(dlg, IDC_COEFFICIENTLIST, value)
	status = DlgGet(dlg, IDC_COEFFICIENTLIST1, values(1))
	status = DlgGet(dlg, IDC_COEFFICIENTLIST2, values(2))
	status = DlgGet(dlg, IDC_COEFFICIENTLIST3, values(3))
	status = DlgGet(dlg, IDC_COEFFICIENTLIST4, values(4))
	status = DlgGet(dlg, IDC_COEFFICIENTLIST5, values(5))
	status = DlgGet(dlg, IDC_COEFFICIENTLIST6, values(6))
	status = DlgGet(dlg, IDC_COEFFICIENTLIST7, values(7))
	status = DlgGet(dlg, IDC_COEFFICIENTLIST8, values(8))
	status = DlgGet(dlg, IDC_COEFFICIENTLIST9, values(9))
	status = DlgGet(dlg, IDC_COEFFICIENTLIST10, values(10))

	do 10 i=1,NumEQ

		read (values(i),*) (A(i,j), j=1,NumEq)

!		read (value,*) (A(i,j), j=1,NumEq),dummy
10	continue
!	read (value,*) ((A(i,j), j=1,NumEq),dummy, i=1,NumEq)
	
	lret = DlgSet(dlg, IDM_START, .false., DLG_ENABLE)
	lret = DlgSet(dlg, IDM_EXIT, .false., DLG_ENABLE)
	!lret = DlgSet(dlg, IDM_STOP, .false., DLG_ENABLE)
		
!	gSetFocus = IDM_STOP
	call GaussSiedel()
	write (value, "(i)") Iterations
	status = DlgSet(dlg, IDC_ITERATION, value)
	
	lret = DlgSet ( dlg, IDC_SOLUTIONLIST, NumEq, DLG_NUMITEMS )	
2	format ('x(',i2, ')= ', f10.5)
	do 20 i=1,NumEq
		write (value,2) i, Solutions(i)
		lret = DlgSet ( dlg, IDC_SOLUTIONLIST, value, i )
20	continue
!	write (value,*) ('x(', i, ')= ', Solutions(i), '\n', i=1,NumEq)
!	status = DlgSet(dlg, IDC_SOLUTIONLIST, value)

	lret = DlgSet(dlg, IDM_START, .true., DLG_ENABLE)
	lret = DlgSet(dlg, IDM_EXIT, .true., DLG_ENABLE)
	!lret = DlgSet(dlg, IDM_STOP, .false., DLG_ENABLE)

  END SUBROUTINE StartWork

!****************************************************************************
!
!  FUNCTION: ProgressStart ( dlg, id, callbacktype )
!
!  PURPOSE:  Dialog box callback for Start button
!
!  COMMENTS:
!
!****************************************************************************

SUBROUTINE GSStart( dlg, id, callbacktype )

  use dflogm
  use GSGlobals

  implicit none

  include 'resource.fd'

  type (dialog) dlg
  integer id, callbacktype

  logical lret

  if (callbacktype == dlg_clicked) then
	  call StartWork( dlg )
  end if

  END SUBROUTINE GSStart

!****************************************************************************
!
!  FUNCTION: StopWork ( dlg )
!
!  PURPOSE:  Cleanup when stopping
!
!  COMMENTS:
!
!****************************************************************************

SUBROUTINE StopWork( dlg )

  use dflogm
  use GSGlobals

  implicit none

  include 'resource.fd'

  type (dialog) dlg

  integer hwnd
  logical lret

	gDoWork = .false.
	lret = DlgSet(dlg, IDM_START, .true., DLG_ENABLE)
	lret = DlgSet(dlg, IDM_EXIT, .true., DLG_ENABLE)
!	lret = DlgSet(dlg, IDM_STOP, .false., DLG_ENABLE)
	gSetFocus = IDM_START

  END SUBROUTINE StopWork

!****************************************************************************
!
!  FUNCTION: ProgressStop ( dlg, id, callbacktype )
!
!  PURPOSE:  Dialog box callback for Stop button
!
!  COMMENTS:
!
!****************************************************************************

SUBROUTINE GSStop( dlg, id, callbacktype )

  use dflogm
  use GSGlobals

  implicit none

  include 'resource.fd'

  type (dialog) dlg
  integer id, callbacktype

  if (callbacktype == dlg_clicked) then
	call StopWork( dlg )
  end if

  END SUBROUTINE GSStop


